VERSION 5.00
Begin VB.Form frmRoman 
   BackColor       =   &H00FFC0C0&
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Decimal para Romanos e Romanos para Decimal"
   ClientHeight    =   4965
   ClientLeft      =   4140
   ClientTop       =   3435
   ClientWidth     =   7365
   BeginProperty Font 
      Name            =   "MS Sans Serif"
      Size            =   12
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "frmRoman.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   4965
   ScaleWidth      =   7365
   StartUpPosition =   2  'CenterScreen
   Begin VB.Frame Frame1 
      BackColor       =   &H00FFC0C0&
      Caption         =   "Selecione o tipo de Converso"
      Height          =   1275
      Left            =   360
      TabIndex        =   0
      Top             =   240
      Width           =   6615
      Begin VB.OptionButton optRomanToDecimal 
         BackColor       =   &H00FFC0C0&
         Caption         =   "Nmero Romano para Nmero Decimal"
         Height          =   315
         Left            =   360
         TabIndex        =   2
         Top             =   840
         Width           =   6015
      End
      Begin VB.OptionButton optDecimalToRoman 
         BackColor       =   &H00FFC0C0&
         Caption         =   "Nmero Decimal para Nmero Romano"
         Height          =   315
         Left            =   360
         TabIndex        =   1
         Top             =   360
         Value           =   -1  'True
         Width           =   5955
      End
   End
   Begin VB.CommandButton cmdSair 
      Caption         =   "&Sair"
      Height          =   615
      Left            =   4560
      TabIndex        =   8
      Top             =   3960
      Width           =   2415
   End
   Begin VB.CommandButton cmdConverter 
      Caption         =   "Con&verter"
      Default         =   -1  'True
      Height          =   735
      Left            =   360
      TabIndex        =   7
      Top             =   3840
      Width           =   2655
   End
   Begin VB.TextBox txtInput 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   435
      Left            =   360
      MaxLength       =   4
      TabIndex        =   4
      Top             =   2160
      Width           =   6615
   End
   Begin VB.Label lblOutput 
      BorderStyle     =   1  'Fixed Single
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   360
      TabIndex        =   6
      Top             =   3240
      Width           =   6615
   End
   Begin VB.Label lblOutputDesc 
      BackStyle       =   0  'Transparent
      Caption         =   "Nmero Romano Equivalmente :"
      Height          =   255
      Left            =   360
      TabIndex        =   5
      Top             =   2760
      Width           =   6375
   End
   Begin VB.Label lblPrompt 
      BackStyle       =   0  'Transparent
      Caption         =   "Entre com um nmero entre 1 e 3999"
      Height          =   255
      Left            =   360
      TabIndex        =   3
      Top             =   1800
      Width           =   6375
   End
End
Attribute VB_Name = "frmRoman"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'--------------------------------------------------------------------------------------
Private Sub optDecimalToRoman_Click()
'--------------------------------------------------------------------------------------
    lblPrompt.Caption = "Entre com um nmero entre 1 e 3999:"
    lblOutputDesc.Caption = "Nmero Romano Equivalente:"
    txtInput.Text = ""
    txtInput.MaxLength = 4
    lblOutput.Caption = ""
End Sub

'--------------------------------------------------------------------------------------
Private Sub optRomanToDecimal_Click()
'--------------------------------------------------------------------------------------
    lblPrompt.Caption = "Entre com um numeral Romano entre I e MMMCMXCIX:"
    lblOutputDesc.Caption = "Nmero Decimal Equivalente :"
    txtInput.Text = ""
    txtInput.MaxLength = 16
    lblOutput.Caption = ""
End Sub

'--------------------------------------------------------------------------------------
Private Sub txtInput_GotFocus()
'--------------------------------------------------------------------------------------
    With txtInput
        .SelStart = 0
        .SelLength = Len(.Text)
    End With
End Sub

'--------------------------------------------------------------------------------------
Private Sub txtInput_KeyPress(KeyAscii As Integer)
'--------------------------------------------------------------------------------------

    If KeyAscii < 32 Then Exit Sub
    
    If optDecimalToRoman.Value = True Then
        If InStr("0123456789", Chr$(KeyAscii)) = 0 Then
            KeyAscii = 0
        End If
    Else
        If Chr$(KeyAscii) >= "a" And Chr$(KeyAscii) <= "z" Then
            KeyAscii = KeyAscii - 32
        End If
        If InStr("MDCLXVI", Chr$(KeyAscii)) = 0 Then
            KeyAscii = 0
        End If
    End If
    
End Sub

'--------------------------------------------------------------------------------------
Private Sub txtInput_Change()
'--------------------------------------------------------------------------------------
    lblOutput.Caption = ""
End Sub

'--------------------------------------------------------------------------------------
Private Sub cmdConverter_Click()
'--------------------------------------------------------------------------------------
    
    Dim intLetterPos            As Integer
    Dim strNumeroRomanoString   As String
    Dim strRomanoInvalidoMsg As String
    
    If optDecimalToRoman.Value = True Then
        If Val(txtInput.Text) < 1 _
        Or Val(txtInput.Text) > 3999 Then
            MsgBox "Nmero fora do intervalo. Informe um nmero entre 1 e 3999.", _
                   vbExclamation, _
                   "Nmero fora do Intervalo"
            txtInput.SetFocus
            Exit Sub
        End If
        
        lblOutput.Caption = ConverterParaRomano(txtInput.Text)
    Else
        strNumeroRomanoString = txtInput.Text
        
        If Not EntraRomanoValida(strNumeroRomanoString, strRomanoInvalidoMsg) Then
            MsgBox strRomanoInvalidoMsg, _
                   vbExclamation, _
                   "Nmero Romano invlido"
            txtInput.SetFocus
            Exit Sub
        End If
            
        lblOutput.Caption = ConverterParaDecimal(txtInput.Text)
    
    End If
    
End Sub

'--------------------------------------------------------------------------------------
Private Sub cmdSair_Click()
'--------------------------------------------------------------------------------------
    End
End Sub

'--------------------------------------------------------------------------------------
Private Function ConverterParaRomano(pstrDecimalNumber As String) As String
'--------------------------------------------------------------------------------------

    Const strPOS_VAL    As String = "IXCM"
    Const strFIVE_VAL   As String = "VLD"
    
    Dim strRoman        As String
    Dim strCurrRomanPos As String
    Dim strLetra1      As String
    Dim strLetra2      As String
    Dim intPosicaoAtual      As Integer
    Dim intDigito        As Integer
    Dim intDigitoPos     As Integer
    
    intPosicaoAtual = 1
    strRoman = ""
    
    For intDigitoPos = Len(pstrDecimalNumber) To 1 Step -1
        intDigito = Val(Mid$(pstrDecimalNumber, intDigitoPos, 1))
        strCurrRomanPos = Mid$(strPOS_VAL, intPosicaoAtual, 1)
        Select Case intDigito
            Case 9
                strLetra1 = strCurrRomanPos
                strLetra2 = Mid$(strPOS_VAL, intPosicaoAtual + 1, 1)
            Case Is > 4
                strLetra1 = Mid$(strFIVE_VAL, intPosicaoAtual, 1)
                strLetra2 = String$(intDigito - 5, strCurrRomanPos)
            Case 4
                strLetra1 = strCurrRomanPos
                strLetra2 = Mid$(strFIVE_VAL, intPosicaoAtual, 1)
            Case Else
                strLetra1 = String$(intDigito, strCurrRomanPos)
                strLetra2 = ""
        End Select
        strRoman = strLetra1 & strLetra1 & strRoman
        intPosicaoAtual = intPosicaoAtual + 1
    Next

    ConverterParaRomano = strRoman

End Function

'--------------------------------------------------------------------------------------
Private Function ConverterParaDecimal(pstrRomanNumeral As String) As String
'--------------------------------------------------------------------------------------

    Dim aintValoresRomanos()   As Integer
    Dim intInputLen         As Integer
    Dim intX                As Integer
    Dim intSum              As Integer
    
    intInputLen = Len(pstrRomanNumeral)
    
    If intInputLen = 0 Then
        ConverterParaDecimal = 0
        Exit Function
    End If
    
    ReDim aintValoresRomanos(1 To intInputLen)
    
    For intX = 1 To intInputLen
        Select Case Mid$(pstrRomanNumeral, intX, 1)
            Case "M":   aintValoresRomanos(intX) = 1000
            Case "D":   aintValoresRomanos(intX) = 500
            Case "C":   aintValoresRomanos(intX) = 100
            Case "L":   aintValoresRomanos(intX) = 50
            Case "X":   aintValoresRomanos(intX) = 10
            Case "V":   aintValoresRomanos(intX) = 5
            Case "I":   aintValoresRomanos(intX) = 1
        End Select
    Next
    
    For intX = 1 To intInputLen
        If intX = intInputLen Then
            intSum = intSum + aintValoresRomanos(intX)
        Else
            If aintValoresRomanos(intX) >= aintValoresRomanos(intX + 1) Then
                intSum = intSum + aintValoresRomanos(intX)
            Else
                intSum = intSum - aintValoresRomanos(intX)
            End If
        End If
    Next
    
    ConverterParaDecimal = CStr(intSum)

End Function

'--------------------------------------------------------------------------------------
Private Function EntraRomanoValida(ByVal pstrRN As String, ByRef pstrMsg As String) _
As Boolean
'--------------------------------------------------------------------------------------
        
    EntraRomanoValida = False         ' falso at provar que  verdadeiro
        
    ' a 'D', 'L', or 'V' pode aparecer somente uma vez na string
    If GetSubstringCount(pstrRN, "D") > 1 _
    Or GetSubstringCount(pstrRN, "L") > 1 _
    Or GetSubstringCount(pstrRN, "V") > 1 Then
        pstrMsg = "'D', 'L', oU 'V' podem aparecer somente uma vez no numeral."
        Exit Function
    End If
    
    ' no pode ter 3 valores consecutivos de Ms, Cs, Xs or Is:
    If InStr(pstrRN, "MMMM") > 0 _
    Or InStr(pstrRN, "CCCC") > 0 _
    Or InStr(pstrRN, "XXXX") > 0 _
    Or InStr(pstrRN, "IIII") > 0 Then
        pstrMsg = "'M', 'C', 'X', or 'I' no podem aparecer mais que 3 vezes no mesmo numeral."
        Exit Function
    End If
    
    ' sequencias ilegais:
    If InStr(pstrRN, "IL") > 0 _
    Or InStr(pstrRN, "IC") > 0 _
    Or InStr(pstrRN, "ID") > 0 _
    Or InStr(pstrRN, "IM") > 0 _
    Or InStr(pstrRN, "XD") > 0 _
    Or InStr(pstrRN, "XM") > 0 _
    Or InStr(pstrRN, "VX") > 0 _
    Or InStr(pstrRN, "VL") > 0 _
    Or InStr(pstrRN, "VC") > 0 _
    Or InStr(pstrRN, "VD") > 0 _
    Or InStr(pstrRN, "VM") > 0 _
    Or InStr(pstrRN, "LC") > 0 _
    Or InStr(pstrRN, "LD") > 0 _
    Or InStr(pstrRN, "LM") > 0 _
    Or InStr(pstrRN, "DM") > 0 _
    Then
        pstrMsg = "O nmero romano possui uma sequncia ilegal de caracteres."
        Exit Function
    End If
    
    ' Outras sequencias ilegais

    ' Uma vez que uma letra foi subtraida, nem ela nem sua contraparte podem aparecer novamente
    ' na string - assim nem X nem V podem seguir IX, neem C nem L podem seguir CX, etc.
    If ASegueBemC("X", "IX", pstrRN) Then pstrMsg = "'X' no pode seguir 'IX'.": Exit Function
    If ASegueBemC("V", "IX", pstrRN) Then pstrMsg = "'V' no pode seguir 'IX'.": Exit Function
    If ASegueBemC("C", "XC", pstrRN) Then pstrMsg = "'C' no pode seguir 'XC'.": Exit Function
    If ASegueBemC("L", "XC", pstrRN) Then pstrMsg = "'L' no pode seguir 'XC'.": Exit Function
    If ASegueBemC("M", "CM", pstrRN) Then pstrMsg = "'M' no pode seguir 'CM'.": Exit Function
    If ASegueBemC("D", "CM", pstrRN) Then pstrMsg = "'D' no pode seguir 'CM'.": Exit Function
    
    If ASegueBemC("C", "CD", pstrRN) Then pstrMsg = "'C' no pode seguir 'CD'.": Exit Function
    If ASegueBemC("C", "CM", pstrRN) Then pstrMsg = "'C' no pode seguir 'CD'.": Exit Function
    If ASegueBemC("X", "XL", pstrRN) Then pstrMsg = "'X' no pode seguir 'XL'.": Exit Function
    If ASegueBemC("X", "XC", pstrRN) Then pstrMsg = "'X' no pode seguir 'XL'.": Exit Function
    If ASegueBemC("I", "IV", pstrRN) Then pstrMsg = "'I' no pode seguir 'IV'.": Exit Function
    If ASegueBemC("I", "IX", pstrRN) Then pstrMsg = "'I' no pode seguir 'IV'.": Exit Function
    
    If ASegueBemC("IV", "I", pstrRN) Then pstrMsg = "'IV' no pode seguir 'I'.": Exit Function
    If ASegueBemC("IX", "I", pstrRN) Then pstrMsg = "'IX' no pode seguir 'I'.": Exit Function
    If ASegueBemC("IX", "V", pstrRN) Then pstrMsg = "'IX' no pode seguir 'V'.": Exit Function
    If ASegueBemC("XL", "X", pstrRN) Then pstrMsg = "'XL' no pode seguir 'X'.": Exit Function
    If ASegueBemC("XC", "X", pstrRN) Then pstrMsg = "'XC' no pode seguir 'X'.": Exit Function
    If ASegueBemC("XC", "L", pstrRN) Then pstrMsg = "'XC' no pode seguir 'L'.": Exit Function
    If ASegueBemC("CD", "C", pstrRN) Then pstrMsg = "'CD' no pode seguir 'C'.": Exit Function
    If ASegueBemC("CM", "C", pstrRN) Then pstrMsg = "'CM' no pode seguir 'C'.": Exit Function
    If ASegueBemC("CM", "D", pstrRN) Then pstrMsg = "'CM' no pode seguir 'D'.": Exit Function
    
    ' o numero romano  valido
    EntraRomanoValida = True

End Function

'--------------------------------------------------------------------------------------
Private Function GetSubstringCount(ByVal pstrMainString As String, _
                                   ByVal pstrSubstring As String) _
As Long
'--------------------------------------------------------------------------------------
    
    Dim lngX As Long
    Dim lngY As Long
    
    If pstrMainString = "" Then
        GetSubstringCount = 0
    Else
        lngX = InStr(1, pstrMainString, pstrSubstring, vbBinaryCompare)
        If lngX = 0 Then
            GetSubstringCount = 0
        Else
            lngX = 0
            For lngY = 1 To Len(pstrMainString)
                If Mid$(pstrMainString, lngY, Len(pstrSubstring)) = pstrSubstring Then
                    lngX = lngX + 1
                End If
            Next lngY
            GetSubstringCount = lngX
        End If
    End If

End Function

'--------------------------------------------------------------------------------------
Private Function ASegueBemC(pstrA As String, pstrB As String, pstrC As String) As Boolean
'--------------------------------------------------------------------------------------
    
    Dim lngTestPos  As Long
    
    lngTestPos = InStr(pstrC, pstrB)
    
    If lngTestPos > 0 Then
        If InStr(lngTestPos + Len(pstrB), pstrC, pstrA, vbTextCompare) Then
            ASegueBemC = True
        Else
            ASegueBemC = False
        End If
    Else
        ASegueBemC = False
    End If
        

End Function
